/* noss.c     nos supervisor

   integrate with Sx1   13 Aug 2006
 */

#include "sx.h"

#define TIMEOUT 500

#define time_out 10
#define stopped  11
#define blocked  12

extern int clock;		// sxm.c
extern int CP, DP;

int sclock, uclock;		// system, user, clock
int status, userp;
int intflag;

void outa(int op, int arg){
	M[CP] = (arg << 8) | op;
	CP++;
}

void decode(int ip, int *op, int *arg){
	int c;
	c = M[ip];
	*op = c & 255;
	*arg = c >> 8;
}

// save c-state to process descriptor a
void saveCstate(int a){
    M[a + 4] = FP;
    M[a + 5] = SP;
    M[a + 6] = PC;
}
// restore c-state from a process desc.
void restoreCstate(int a){
    userp = a;
    FP = M[a + 4];
    SP = M[a + 5];
    PC = M[a + 6];	// cause a jump
}

// run until timeout/blocked/stopped
void eval(int ref){
	int op, arg;
    clock = 0;
    runflag = 1;
	PC = ref;
    while(runflag ) {
        if( intflag )
            if( clock > TIMEOUT ){
               status = time_out;
               break;
            }
		decode(PC,&op,&arg);
		if(op == icCall)
			printf("call %s\n",searchref(arg));
		run3();
    }
	saveCstate(userp);
}

void boot(void){
    int callswitchp;
    int a_activep, a_status, a_switchp;

    a_activep = searchsym("activep");
    a_status = searchsym("status");
    a_switchp = searchsym("switchp");
    callswitchp = CP;
    outa(icCall,a_switchp);
    outa(icEnd,0);

    sclock = 0;
    eval(1);       // boot nos
    sclock += clock;
exit(0);

    while(M[a_activep] != 0){	// interrupt-execute loop
        M[a_status] = status;	// update to nos
        printf(" * ");
        eval(callswitchp);		// run switcher
        sclock += clock;
    }
}

int main(int argc, char *argv[]){
  if( argc < 2 ) {
    printf("usage : noss objfile\n");
    exit(0);
  }
  loadobj(argv[1]);
  initchip();
//  interp();
//  outprof();
  boot();
  return 0;
}

